## ---- include=FALSE---------------------------------------------------------------------------------------------------
knitr::opts_chunk$set(fig.width=4, fig.height=3.5)

## ---------------------------------------------------------------------------------------------------------------------
library("lessR")

## ----read-------------------------------------------------------------------------------------------------------------
d <- Read("Employee")

## ----sp---------------------------------------------------------------------------------------------------------------
Plot(Years, Salary)

## ----spEnhance--------------------------------------------------------------------------------------------------------
Plot(Years, Salary, enhance=TRUE)

## ----size-------------------------------------------------------------------------------------------------------------
Plot(Years, Salary, size=Pre)

## ----by, fig.width=5--------------------------------------------------------------------------------------------------
Plot(Years, Salary, by=Gender)

## ---- fig.height=4----------------------------------------------------------------------------------------------------
Plot(Years, Salary, by1=Gender)

## ---------------------------------------------------------------------------------------------------------------------
Plot(Dept, Gender)

## ---------------------------------------------------------------------------------------------------------------------
Plot(Salary)

## ---------------------------------------------------------------------------------------------------------------------
Plot(Dept)

## ---- fig.height=5.5--------------------------------------------------------------------------------------------------
Plot(Salary, row_names)

## ---- fig.height=5.5--------------------------------------------------------------------------------------------------
Plot(Salary, row_names, sort_yx="0", segments_y=FALSE)

## ---- fig.width=5, fig.height=5.5-------------------------------------------------------------------------------------
Plot(c(Pre, Post), row_names)

## ---------------------------------------------------------------------------------------------------------------------
d <- Read("StockPrice")
d[1:5,]

## ---------------------------------------------------------------------------------------------------------------------
Plot(date, Price, rows=(Company=="Apple"))

## ---- fig.width=5-----------------------------------------------------------------------------------------------------
Plot(date, Price, by=Company)

## ---- fig.width=4.5---------------------------------------------------------------------------------------------------
Plot(date, Price, by1=Company)

## ---- fig.width=4.5---------------------------------------------------------------------------------------------------
style(sub_theme="black", trans=.55,
      window_fill="gray10", grid_color="gray25")
Plot(date, Price, by1=Company, n_col=1,  fill="darkred", color="red")

## ---------------------------------------------------------------------------------------------------------------------
d <- Read("Employee")

## ----fig.width=4.5----------------------------------------------------------------------------------------------------
Plot(Years, Salary, add=c("Hi", "Bye", "Wow"), x1=c(12, 16, 18),
  y1=c(80000, 100000, 60000))

## ----fig.width=4.5----------------------------------------------------------------------------------------------------
style(add_trans=.8, add_fill="gold", add_color="gold4", add_lwd=0.5)
Plot(Years, Salary, add="rect", x1=12, y1=80000, x2=16, y2=115000)

